#ifndef __EDGECONDITIONS_H__
#define __EDGECONDITIONS_H__

#include "algorithm.h"
#include "Utility.h"

template<class C, class T>
void GenerateEdges(const CodedSequenceList_t& list, const C& cond, const T& bop)
{
	CodedSequenceList_t::const_iterator iter = list.begin();
	CodedSequenceList_t::const_iterator iterEnd = list.end();
	CodedSequenceList_t::const_iterator iterEndPrev = iterEnd-1;

	for (; iter != iterEndPrev; ++iter)
	{
		CodedSequenceList_t::const_iterator secondIter = iter + 1;
		for (;secondIter != iterEnd; ++secondIter)
			if (cond(*iter, *secondIter))
				bop(*iter, *secondIter);
	}
}

struct distance_condition
	: public std::binary_function<CodedSequence_t, CodedSequence_t, bool>
{
	distance_condition(int n)
		: m_n(n)
	{
	}

	bool operator()(const CodedSequence_t& first, const CodedSequence_t& second) const;

private:
	int m_n;
};



#endif