#include "stdafx.h"
#include "SequenceBlock.h"
#include "GroupDef.h"
#include "SequenceElement.h"
#include "Utility.h"

SequenceBlock::SequenceBlock(FiniteAbelianGroup& g, const Sequence_t& rSequence, const Set_t& rSubsums)
	: m_Group(g), m_Sequence(rSequence)
{

	Set_t inverses;

	SetToVectorBool(g, rSubsums, m_Subsums);

	Set_t::const_iterator iter = rSubsums.begin();
	Set_t::const_iterator iterEnd = rSubsums.end();
	for (; iter != iterEnd; ++iter)
		inverses.insert(g.Inverse(**iter));

	Set_t L2;
	std::set_difference
	(
		g.pool_begin(), g.pool_end(), 
		inverses.begin(), inverses.end(), 
		std::inserter(L2, L2.end()),
		val_less<GroupElement*>()
	);

	SetToVectorBool(g, L2, m_Complements);
}

SequenceBlock::SequenceBlock(const SequenceBlock& rhs)
	: m_Group(rhs.m_Group), m_Sequence(rhs.m_Sequence), m_Complements(rhs.m_Complements)
{
}


bool SequenceBlock::operator < (const SequenceBlock& rhs) const
{
	VectorCompare_t compare;

	return compare(m_Sequence, rhs.m_Sequence);
}
