#ifndef __SEQUENCECLASSES_H__
#define __SEQUENCECLASSES_H__

#include "Typedef.h"

class OrderClass
{
public:
	int GetOrderValue(int nOrder) const;
	void SetOrderValue(int nOrder, int nVal);


	std::ostream& ToStream(std::ostream& rStream) const;

	int& operator[](int nOrder);
	int operator[](int nOrder) const;

	//bool operator == (const OrderClass& rhs) const;
	bool operator < (const OrderClass& rhs) const;
	//bool operator != (const OrderClass& rhs) const;

	int length() const {return m_Lookup.size();}

private:

	friend class Group;

	typedef	std::map<int, int>	Lookup_t;

	OrderClass(const std::vector<int>& rDivisorList);

	Lookup_t	m_Lookup;
};

std::ostream& operator << (std::ostream& stream, const OrderClass& rhs);


class MultiplicityClass
{
	typedef	std::multiset<int>	Lookup_t;

public:
	std::ostream& ToStream(std::ostream& rStream) const;

	//bool operator == (const MultiplicityClass& rhs) const;
	bool operator < (const MultiplicityClass& rhs) const;
	//bool operator != (const MultiplicityClass& rhs) const;

	int length() const {return m_Lookup.size();}

private:

	friend class Group;

	MultiplicityClass(const CodedSequence_t& rSequence);

	Lookup_t	m_Lookup;
};

std::ostream& operator << (std::ostream& stream, const MultiplicityClass& rhs);

#endif