#ifndef __TYPEDEF_H__
#define __TYPEDEF_H__

#include "algorithm.h"

class GroupElement;
class OrderClass;
class MultiplicityClass;

typedef vector_less<GroupElement*, val_less<GroupElement*> >					VectorCompare_t;

//Compares one pair against another pair, using different operations for the first
//and second items in the pair
typedef pair_less<GroupElement*, int, val_less<GroupElement*>, std::less<int> >	PairCompare_t;

//Defines a type for comparing one map against another map, where pairs in the map are
//compared according to PairCompare_t
typedef map_less<GroupElement*, int, PairCompare_t>								MapCompare_t;

typedef std::vector<GroupElement*>				Sequence_t;
typedef std::set<Sequence_t, VectorCompare_t>	SortedSequenceList_t;


typedef std::map<GroupElement*, int, val_less<GroupElement*> >	CodedSequence_t;
typedef std::vector<CodedSequence_t>							CodedSequenceList_t;

typedef std::map<GroupElement*, int, val_less<GroupElement*> >	ElmtOrderLookup_t;

typedef std::multiset<GroupElement*, val_less<GroupElement*> >	Multiset_t;
typedef std::set<GroupElement*, val_less<GroupElement*> >	Set_t;
typedef std::map<int, int>	LengthMap_t;

typedef std::map<OrderClass*, int, val_less<OrderClass*> >	OrderClassStats_t;

typedef std::map<MultiplicityClass*, int, val_less<MultiplicityClass*> >	MultiplicityClassStats_t;

typedef std::pair<MultiplicityClass*, OrderClass*>	OMPair_t;
typedef pair_less<OMPair_t::first_type, OMPair_t::second_type, val_less<OMPair_t::first_type>, val_less<OMPair_t::second_type> > OMPairCompare_t;
typedef std::map<OMPair_t, int, OMPairCompare_t>	OrderMultComboStats_t;

#endif